# 3. Feladat - Hálózati kommunikáció - port szkenner 

## 3.a Feladat - Time szerver 

**Feladat:** Írjunk Python szkriptet `time_server.py` néven, ami megvalósít egy pontos időt visszaadó, 
TCP alapú szerver funkciót. A szerver a kliensek kapcsolódása után szimplán adja vissza a pontos időt 
(a klienseket külön szálon kezelve), majd bontsa a kapcsolatot.

A forráskód:

```python
#!/usr/bin/env python3

from socketserver import BaseRequestHandler, ThreadingTCPServer
import time
import argparse


class MyHandler(BaseRequestHandler):
    def handle(self):
        self.request.sendall(str.encode(time.ctime()))


if __name__ == "__main__":
    parser = argparse.ArgumentParser(description="Time server")
    parser.add_argument('--ip', type=str)
    parser.add_argument('--port', type=int)
    args = parser.parse_args()
    a = vars(args)
    HOST, PORT = a["ip"], int(a["port"])
    server = ThreadingTCPServer((HOST, PORT), MyHandler)
    try:
        server.serve_forever()
    except KeyboardInterrupt:
        server.shutdown()
```

Futtatás:

```bash
$ chmod +x time_server.py
$ ./time_server.py --ip="localhost" --port=9999
```

Tesztelés:

```bash
$ nc localhost 9999
Mon Mar  7 17:56:58 2022
```